#include "eda/eda-io.h"
#include <unistd.h>
#include "stdlib.h"
#include <iostream>

void trigger_trigger(int b){
    printf("[Test] Tirgger trigger: %d\n", b);
}

void trigger_tune(int b){
    printf("[Test] Tirgger tune: %d\n", b);
}

void trigger_input(int b){
    printf("[Test] Tirgger input: %d\n", b);
}

#ifdef ENABLE_GS
void trigerr_hardware(){
    printf("[Test] Harderware trigger.\n");
}
#endif

int main(int argc, char *argv[]){
    eda::EdaIo *em = eda::EdaIo::getInstance();
    em->registerTrigger(trigger_trigger);
    em->registerInput(trigger_input);
    em->registerTune(trigger_tune);

    
#ifdef ENABLE_GS
    // Need work mode: 2 or 3
    em->registerHardware(trigerr_hardware);
#endif
    em->setup();
    int mod;
    printf("[Input] work mode[0: CONTINUE, 1: Software, 2: Rising edge ,3: Falling edge]: ");
    std::cin >> mod;
    em->setWorkMode(mod);
#ifdef ENABLE_LIGHT_TIGGER
    em->setLightFlashCount(7);
    em->setLightFlashTime(2);
#endif 
    em->enableLightSection(1);
    em->enableLightSection(2);
    em->enableLightSection(3);
    em->enableLightSection(4);
#ifdef ENABLE_LIQUID
    em->setLiquid(7900);
    int t_liquid = em->getLiquid();
    std::cout << "Liquid: " << t_liquid << std::endl;
#endif
    std::cout << "RGB Color \n----------------\n    0: white\n    1: Red\n    2: Green\n    3: Blue" << std::endl;
    int ci=0;
    while (1)
    {
        std::cout << "rgb color(0~3): ";
        std:: cin >> ci;     
        if(ci == 0 || ci == 1 || ci == 2 || ci ==3){     
#ifdef SUPPORT_LIGHT_CUSTOM
            em->open_light();   
            sleep(ci);
            em->close_light();       
#endif      
            em->setRgbLight(ci);
            if(ci == 1){
#ifdef ENABLE_LIGHT_TIGGER   
                em->callLightFlash();
#endif
                em->openLaser();
                em->setScanStat(true);
                em->setDo1High(true);
                em->setDo2High(true);
            }else if(ci == 0){
                em->closeLaser();
                em->setScanStat(false);
                em->setDo1High(false);
                em->setDo2High(false);
            }
        }else if(ci == 10){
            break;
        }
        sleep(1);
    }
    em->disableLightSection(1);
    em->disableLightSection(2);
    em->disableLightSection(3);
    em->disableLightSection(4);
    eda::EdaIo::close_io();
    return 0;
}