#!/usr/bin/python3
import time
from libedaio2 import EdaIo,registerInput,registerTrigger,registerTune
import sys

def func_input(v):
    print("[Debug] Trigger: input!", v)

def func_trigger(v):
    print("[Debug] Trigger: trigger button!", v)

def func_tune(v):
    print("[Debug] Trigger: tune button!", v)

def func_hardware():
    print("[Debug] Trigger: Hardware!")

def main() -> int:
    eda = EdaIo.singleton();
    registerInput(func_input)
    registerTrigger(func_trigger)
    registerTune(func_tune)
    eda.setup()
    eda.setWorkMode(2)
    while True:
        a = input("Set [0~5]: ")
        if a == "0":
            eda.setRgbLight(0)
        elif a == "1":
            eda.setRgbLight(1)
        elif a == "2":
            eda.setRgbLight(2)
        elif a == "3":
            eda.setRgbLight(3)
        elif a == "4":
            eda.setRgbLight(4)
        elif a == "5":
            eda.setRgbLight(5)
        else:
            break
    
    eda.setWorkMode(5)
    eda.enableLightSection(1)
    eda.enableLightSection(2)
    eda.enableLightSection(3)
    eda.enableLightSection(4)
    eda.setLightFlashCount(20)
    eda.setLightFlashTime(1)

    eda.setStrobeManual(1)

    eda.setBrightnessValue(20)
    eda.open_light()
    time.sleep(2)
    print("[main] close")
    eda.close_light()
    time.sleep(0.5)

    eda.setBrightnessValue(479)
    eda.open_light()
    time.sleep(2)
    print("[main] close")
    eda.close_light()
    time.sleep(0.5)

    eda.setBrightnessValue(279)
    eda.open_light()
    time.sleep(2)
    print("[main] close")
    eda.close_light()
    time.sleep(0.5)

    return 0;

if __name__ == "__main__":
    sys.exit(main())